# libvlcpp

[![Join the chat at https://discord.gg/3h3K3JF](https://img.shields.io/discord/716939396464508958?label=discord)](https://discord.gg/3h3K3JF)

[libvlcpp](https://code.videolan.org/videolan/libvlcpp) is a header-only, C++ bindings for the libvlc crossplatform multimedia API. It is an official binding over the VideoLAN libvlc library and can be used on many platforms.

## Documentation

Since libvlcpp is a close wrapper over libvlc, your documentation needs will be best served by either checking the libvlcpp source code, or the [libvlc documentation](https://www.videolan.org/developers/vlc/doc/doxygen/html/group__libvlc.html).

## Issues

libvlcpp tickets are located on our [GitLab](https://code.videolan.org/videolan/libvlcpp/-/issues).

## Contribution

Contribution are always welcome!

Feel free to open a merge request on our [GitLab](https://code.videolan.org/videolan/libvlcpp/-/merge_requests).

## Examples

For usage examples, head over to the examples folder where you will find several code samples, such as [helloworld](examples/helloworld/main.cpp) and more.

## Used by

libvlcpp is being used and tested extensively in various projects, such as the VideoLAN [medialibrary](https://code.videolan.org/videolan/medialibrary), the previous [VLC for UWP](https://code.videolan.org/videolan/vlc-winrt) app and more.